﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;

namespace WindowsFormsApplication5
{
    class Ball
    {
        int d = 10; // диаметр
        SolidBrush c;
        Point p;
        Point v;
        static Random rnd = new Random();

        public Ball(int X, int Y)
        {
            p.X = X; p.Y = Y;
            v.X = rnd.Next(-5, +5);
            v.Y = rnd.Next(-5, +5);
            d = rnd.Next(5, 20);
            c = new SolidBrush(Color.FromArgb(255,rnd.Next(256),0,rnd.Next(256)));
            
        }

        public void Step(int W, int H)
        {
            p.X += v.X; p.Y += v.Y;
            if (p.X-d/2 < 0) v.X = Math.Abs(v.X);
            if (p.Y-d/2 < 0) v.Y = Math.Abs(v.Y);
            if (p.X+d/2 > W) v.X =-Math.Abs(v.X);
            if (p.Y+d/2 > H) v.Y =-Math.Abs(v.Y);
        }

        public void SetVelocity(Point Z)
        {
            v.X = Z.X; v.Y = Z.Y;
        }

        public void Paint(Graphics g)
        {
            g.FillEllipse(c, p.X - d / 2, p.Y - d / 2, d, d);

        }

        public Point Coord
        {
            get { return p; }
        }

        public Point Velocity
        {
            get { return v; }
        }

        public int R
        {
            get { return d / 2; }
        }

    } // Ball

    class Balls
    {
        readonly int MaxBalls;
        int num = 0;

        static int sqr(int x) { return x * x; }

        Ball[] b;

        public Balls(int N)
        {
            b = new Ball[MaxBalls=N];
        }

        public Balls():this(100)
        { 
        }

        public int Add(int X, int Y)
        {
            if (num < MaxBalls)
            {
                b[num++] = new Ball(X, Y);
                return num;
            }
            else return 0;
        }

        public int Num
        {
            get { return num; }
        }

        public void Step(int W, int H)
        {
            for (int i=0; i<num; i++)
                for (int j=i+1; j<num; j++)
                    if (
                        sqr(b[i].Coord.X-b[j].Coord.X)+
                        sqr(b[i].Coord.Y-b[j].Coord.Y)<=
                        sqr(b[i].R+b[j].R)
                        )
                    {
                        Point U = new Point(b[i].Velocity.X, b[i].Velocity.Y);
                        b[i].SetVelocity(b[j].Velocity);
                        b[j].SetVelocity(U);
                    }

            
            for (int i = 0; i < num; i++) b[i].Step(W,H);
        }

        public void Paint(Graphics g)
        {
            for (int i = 0; i < num; i++) b[i].Paint(g);
        }

    }
}

